function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/no-explicit-any */
var WebWorkerClient = /*#__PURE__*/function () {
  function WebWorkerClient(worker) {
    var _this = this;
    _classCallCheck(this, WebWorkerClient);
    _defineProperty(this, "events", void 0);
    _defineProperty(this, "worker", void 0);
    this.events = {};
    this.worker = worker;
    this.worker.onmessage = function (e) {
      var topic = e.data.topic;
      _this.exec(topic, e.data);
    };
  }
  _createClass(WebWorkerClient, [{
    key: "once",
    value: function once(topic, callback) {
      var _this2 = this;
      var on = function on(args) {
        _this2.off(topic, on);
        callback(args);
      };
      return this.on(topic, on);
    }
  }, {
    key: "on",
    value: function on(topic, callback) {
      if (!this.events[topic]) {
        this.events[topic] = [];
      }
      this.events[topic].push(callback);
      return this;
    }
  }, {
    key: "off",
    value: function off(topic, callback) {
      if (!Array.isArray(this.events[topic])) {
        return this;
      }
      this.events[topic] = this.events[topic].filter(function (f) {
        return f !== callback;
      });
      return this;
    }
  }, {
    key: "exec",
    value: function exec(topic, data) {
      if (!Array.isArray(this.events[topic])) {
        return this;
      }
      this.events[topic].forEach(function (callback) {
        callback(data);
      });
      return this;
    }
  }, {
    key: "send",
    value: function send(topic) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      this.worker.postMessage(_objectSpread({
        topic: topic
      }, payload));
      return this;
    }
  }, {
    key: "terminate",
    value: function terminate() {
      this.worker.terminate();
      return this;
    }
  }]);
  return WebWorkerClient;
}();
export default WebWorkerClient;