function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { CloseCircleFilled, SearchOutlined, UpOutlined, DownOutlined, ReloadOutlined, LoadingOutlined } from '@ant-design/icons';
import "./index.less";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { jsx as _jsx } from "react/jsx-runtime";
var TerminalViewerHeader = function TerminalViewerHeader(_ref) {
  var _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? '请输入' : _ref$placeholder,
    defaultValue = _ref.defaultValue,
    _ref$clearable = _ref.clearable,
    clearable = _ref$clearable === void 0 ? true : _ref$clearable,
    _ref$refreshable = _ref.refreshable,
    refreshable = _ref$refreshable === void 0 ? true : _ref$refreshable,
    _ref$loading = _ref.loading,
    loading = _ref$loading === void 0 ? false : _ref$loading,
    _ref$activeTitleIndex = _ref.activeTitleIndex,
    activeTitleIndex = _ref$activeTitleIndex === void 0 ? 0 : _ref$activeTitleIndex,
    titles = _ref.titles,
    searchResult = _ref.searchResult,
    inputAddonBefore = _ref.inputAddonBefore,
    inputAddonAfter = _ref.inputAddonAfter,
    icons = _ref.icons,
    onTitleChange = _ref.onTitleChange,
    onSearchPrev = _ref.onSearchPrev,
    onSearchNext = _ref.onSearchNext,
    onSearchChange = _ref.onSearchChange,
    onSearchClear = _ref.onSearchClear,
    onRefresh = _ref.onRefresh;
  var _useState = useState(defaultValue || ''),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var inputRef = useRef(null);
  var handleInputChange = useCallback(function (e) {
    setValue(e.target.value);
    if (onSearchChange instanceof Function) {
      onSearchChange(e);
    }
  }, [onSearchChange]);
  var handleSearchPrev = function handleSearchPrev() {
    if (onSearchPrev instanceof Function) {
      onSearchPrev(value || '');
    }
  };
  var handleSearchNext = function handleSearchNext() {
    if (onSearchNext instanceof Function) {
      onSearchNext(value || '');
    }
  };
  var handleSearchClear = function handleSearchClear(e) {
    setValue('');
    if (onSearchClear instanceof Function) {
      onSearchClear(e);
    }
  };
  // 切换 Tab 清空搜索框
  useEffect(function () {
    setValue('');
  }, [activeTitleIndex]);
  return /*#__PURE__*/_jsxs("div", {
    className: "terminal-viewer-header",
    children: [/*#__PURE__*/_jsx("div", {
      className: "terminal-viewer-header-tab",
      children: Array.isArray(titles) && titles.map(function (title, index) {
        var itemClassName = ['terminal-viewer-header-tab-item', index === activeTitleIndex && 'active'].filter(Boolean).join(' ');
        var handleTitleChange = function handleTitleChange(i) {
          if (typeof onTitleChange === 'function') {
            onTitleChange(i);
          }
        };
        if (typeof title === 'number') {
          return /*#__PURE__*/_jsxs("div", {
            className: itemClassName,
            onClick: function onClick() {
              return handleTitleChange(index);
            },
            children: ["Tab", title + 1]
          }, title);
        }
        return (
          /*#__PURE__*/
          // eslint-disable-next-line react/no-array-index-key
          _jsx("div", {
            className: itemClassName,
            onClick: function onClick() {
              return handleTitleChange(index);
            },
            children: title
          }, index)
        );
      })
    }), /*#__PURE__*/_jsxs("div", {
      className: "terminal-viewer-header-action",
      children: [inputAddonBefore, refreshable && /*#__PURE__*/_jsx("span", {
        className: "terminal-viewer-header-refresh",
        onClick: loading ? undefined : onRefresh,
        children: loading ? (icons === null || icons === void 0 ? void 0 : icons.loading) || /*#__PURE__*/_jsx(LoadingOutlined, {}) : (icons === null || icons === void 0 ? void 0 : icons.refresh) || /*#__PURE__*/_jsx(ReloadOutlined, {})
      }), /*#__PURE__*/_jsxs("div", {
        className: "terminal-viewer-input-wrapper",
        children: [/*#__PURE__*/_jsx("input", {
          ref: inputRef,
          type: "text",
          value: value,
          className: "terminal-viewer-input",
          onChange: handleInputChange,
          placeholder: placeholder,
          onKeyDown: function onKeyDown(e) {
            if (e.key === 'Enter') {
              handleSearchNext();
            }
          }
        }), /*#__PURE__*/_jsxs("div", {
          className: "terminal-viewer-input-suffix",
          children: [!!value && /*#__PURE__*/_jsx("span", {
            className: "input-suffix-search-result",
            children: "".concat(((searchResult === null || searchResult === void 0 ? void 0 : searchResult.resultCount) || 0) > 0 ? ((searchResult === null || searchResult === void 0 ? void 0 : searchResult.resultIndex) || 0) + 1 : 0, "/").concat(((searchResult === null || searchResult === void 0 ? void 0 : searchResult.resultCount) || 0) >= 1000 ? '1000+' : (searchResult === null || searchResult === void 0 ? void 0 : searchResult.resultCount) || 0)
          }), clearable && !!value && /*#__PURE__*/_jsx("span", {
            className: "input-suffix-clear",
            onClick: handleSearchClear,
            children: (icons === null || icons === void 0 ? void 0 : icons.clear) || /*#__PURE__*/_jsx(CloseCircleFilled, {})
          }), /*#__PURE__*/_jsx("span", {
            className: "input-suffix-search-tool",
            onClick: handleSearchPrev,
            children: (icons === null || icons === void 0 ? void 0 : icons.up) || /*#__PURE__*/_jsx(UpOutlined, {})
          }), /*#__PURE__*/_jsx("span", {
            className: "input-suffix-search-tool",
            onClick: handleSearchNext,
            children: (icons === null || icons === void 0 ? void 0 : icons.down) || /*#__PURE__*/_jsx(DownOutlined, {})
          }), (icons === null || icons === void 0 ? void 0 : icons.search) || /*#__PURE__*/_jsx(SearchOutlined, {})]
        })]
      }), inputAddonAfter]
    })]
  });
};
export default TerminalViewerHeader;